Attribute VB_Name = "modParseUtils"
Option Explicit
'HuntERR Add-In, version 1.0, 07/06/2001
'URFIN JUS (www.urfinjus.net)
'General string manipulation methods

Public Const STR_ONERRORGOTO = "On Error Goto "
Public Const INDENT = "    "

Public Function IsComment(ByVal sLine As String) As Boolean
    IsComment = StartsWith(sLine, "'") Or StartsWith(sLine, "Rem")
End Function

Public Function IsCommentOrEmpty(ByVal sLine As String) As Boolean
    IsCommentOrEmpty = (Trim$(sLine) = "") Or IsComment(sLine)
End Function

Public Function IsTrivialAssignment(ByVal sLine As String) As Boolean
    Dim arrTemp() As String
    IsTrivialAssignment = False
    ParseToken "Set ", sLine
    arrTemp = Split(sLine, "=")
    If UBound(arrTemp) <> 1 Then Exit Function
    IsTrivialAssignment = IsSimpleName(arrTemp(0)) And IsSimpleName(arrTemp(1))
End Function

Public Function IsSimpleName(ByVal sName As String) As Boolean
    IsSimpleName = (InStr(1, Trim$(sName), " ") = 0) _
                    And InStr(1, Trim$(sName), "(") = 0 _
                    And InStr(1, Trim$(sName), ".") = 0
End Function
'Breaks too long code line into several lines with specified max length.
'The main problem is to keep track whether current break is inside string constant or not
Public Function BreakLine(ByVal sSrcLine As String, _
                          Optional ByVal MaxLen As Long = 100, _
                          Optional ByVal BreakAtChar As String = ",") As String
    Const sBreak = " _" & vbNewLine & INDENT & INDENT 'Break when not in string constant
    Const sBreakInStr = """ & _ " & vbNewLine & INDENT & INDENT & """" 'Break when in string constant
    Dim sResLine As String, arrTokens() As String, i As Long, bInString As Boolean, sCurrLine As String, sTkn As String
    On Error GoTo errHandler
    arrTokens = Split(sSrcLine, BreakAtChar)
    For i = 0 To UBound(arrTokens)
        sTkn = arrTokens(i)
        If Len(sCurrLine) + Len(sTkn) > MaxLen Then
            sResLine = sResLine & sCurrLine & BreakAtChar & IIf(bInString, sBreakInStr, sBreak)
            sCurrLine = ""
        End If
        If sCurrLine <> "" Then sCurrLine = sCurrLine & BreakAtChar
        sCurrLine = sCurrLine & sTkn
        'bInString is True if last char of sCurrLine is inside string constant
        If IsOddNumber(StrCount(sTkn, """")) Then bInString = Not bInString
    Next i
    sResLine = sResLine & sCurrLine 'Attach the remainder
    BreakLine = sResLine
    Exit Function
errHandler:
    ErrorIn "BreakLine(sSrcLine,MaxLen,BreakAtChar)", Array(sSrcLine, MaxLen, BreakAtChar)
End Function

Public Function IsOddNumber(ByVal N As Long)
    IsOddNumber = ((N Mod 2) = 1)
End Function

Public Function StrCount(ByVal St As String, ByVal SubStr As String) As Long
    If InStr(1, St, SubStr) = 0 Then Exit Function 'returning 0
    StrCount = UBound(Split(St, SubStr))
End Function

Public Function ParseOnErrorGoto(ByVal sLine As String, ByRef sLbl As String) As Boolean
    If StartsWith(sLine, STR_ONERRORGOTO) Then
        sLbl = Trim$(Mid$(Trim$(sLine), Len(STR_ONERRORGOTO) + 1))
        ParseOnErrorGoto = True
    End If
End Function

Public Sub EmptyStringConstants(ByRef sLine As String)
    Dim arrTemp() As String, i As Long
    arrTemp = Split(sLine, """")
    For i = 1 To UBound(arrTemp) Step 2
        arrTemp(i) = ""
    Next i
    sLine = Join(arrTemp, """")
End Sub

Public Sub CommentDelete(ByRef sLine As String, ByVal Comment As Boolean)
    If Comment Then
        If Not IsComment(sLine) Then sLine = "'" & sLine
        Else
        sLine = ""
    End If
End Sub

Public Function ParseLabel(ByRef sLine As String, ByRef sLabel As String) As Boolean
    Dim arrTemp() As String
    On Error GoTo errHandler
    sLabel = ""
    arrTemp = Split(Trim$(sLine), " ")
    If UBound(arrTemp) = -1 Then Exit Function
    If EndsWith(arrTemp(0), ":") Then
        If InStr(1, arrTemp(0), """") > 0 Then Exit Function  ' may be like this -    Obj.Prop("xys: ") = 1
        sLabel = arrTemp(0)
        sLabel = Left$(sLabel, Len(sLabel) - 1)
        arrTemp(0) = ""
        sLine = Join(arrTemp, " ")
        ParseLabel = True
    End If
    Exit Function
errHandler:
    ErrorIn "ParseLabel(sLine,sLabel)", Array(sLine, sLabel)
End Function

Public Sub ParseParamName(ByVal sDecl As String, sParamName As String)
    Dim arrTokens() As String
    sDecl = Replace(sDecl, "()", " ") 'to make for array parameters
    ParseToken "Optional", sDecl
    ParseToken "ByVal", sDecl
    ParseToken "ByRef", sDecl
    ParseToken "ParamArray", sDecl
    arrTokens = Split(Trim$(sDecl), " ")
    If UBound(arrTokens) >= 0 Then sParamName = arrTokens(0) Else sParamName = ""
End Sub

Public Function FindWords(ByVal sWords As String, _
            ByRef sFoundWord As String, ByRef sLine As String) As Boolean
    Dim arrTokens() As String, i As Long
    On Error GoTo errHandler
    arrTokens = Split(sWords, ",")
    For i = LBound(arrTokens) To UBound(arrTokens)
        If ParseToken(arrTokens(i), sLine) Then
            sFoundWord = arrTokens(i)
            FindWords = True
            Exit Function
        End If
    Next i
    sFoundWord = ""
    Exit Function
errHandler:
    ErrorIn "FindWords(sWords,sFoundWord,sLine)", Array(sWords, sFoundWord, sLine)
End Function

Public Function ParseToken(ByVal sToken As String, ByRef sLine As String) As Boolean
    Dim sL As String
    sL = Trim$(sLine)
    If StartsWith(sL, sToken) Then
        sLine = Trim$(Mid$(sL, Len(sToken) + 1))
        ParseToken = True
        Exit Function
    End If
    Exit Function
errHandler:
    ErrorIn "ParseToken(sToken,sLine)", Array(sToken, sLine)
End Function

Public Function StartsWith(ByVal sLine As String, ByVal WithStr As String) As Boolean
    On Error Resume Next
    StartsWith = (Left$(Trim$(UCase(sLine)), Len(WithStr)) = UCase$(WithStr))
End Function

Public Function EndsWith(ByVal sLine As String, ByVal WithStr As String) As Boolean
    On Error Resume Next
    EndsWith = (Right$(Trim$(sLine), Len(WithStr)) = WithStr)
End Function


